// SPRITE.H
// Definicin generica de valores para los registros y de posiciones en memoria. as como varias estructuras de datos.
// Estas definiciones se han respetado de un estandar dentro de la GBA SCENE.

#ifndef SPRITE_H
#define SPRITE_H

//Propiedades del ATRIBUTO0 de los Sprites
#define ROTATION_FLAG 		0x100
#define SIZE_DOUBLE			0x200
#define MODE_NORMAL     	0x0
#define MODE_TRANSPERANT	0x400
#define MODE_WINDOWED		0x800
#define MOSAIC				0x1000
#define COLOR_16			0x0000
#define COLOR_256			0x2000
#define SQUARE			0x0
#define TALL			0x4000
#define WIDE			0x8000

//Propiedades del ATRIBUTO1 de los Sprites
#define ROTDATA(n)		((n) << 9)
#define HORIZONTAL_FLIP		0x1000
#define VERTICAL_FLIP		0x2000
#define SIZE_8			0x0
#define SIZE_16			0x4000
#define SIZE_32			0x8000
#define SIZE_64			0xC000


//Propiedades del ATRIBUTO2 de los Sprites

#define PRIORITY(n)		((n) << 10)
#define PALETTE(n)		((n) << 12)


// Estructuras de datos para los sprites

typedef struct tagOAMEntry
{
	u16 attribute0;
	u16 attribute1;
	u16 attribute2;
	u16 attribute3;
}OAMEntry;


//Declaracin de variables para los sprites.
u16* OAM = (u16*)0x7000000; //Posicion de memoria OAM
OAMEntry sprites[128]; //Variable de los sprites



#endif